import java.awt.image.*;
import java.awt.*;

public class Fill{
    BufferedImage bim;    
    static int old; //Original Color you're looking for
    static int fill; //The new color to fill in the pixel with
    static int index; //Your current position in the array
    static int eastBound;
    static int southBound;
    coords [] pixels;
    coords cur;
    
    public Fill(BufferedImage in, int x1, int y1, int filler){        
        fill = filler;
        bim = in;
        index = 0;
        old = in.getRGB(x1,y1);
        
        eastBound = in.getWidth();
        southBound = in.getHeight();
        
        pixels = new coords[eastBound*southBound];        
        pixels[index] = new coords(x1,y1);        
        bim.setRGB(x1,y1,fill);
        try{
        fillIt();
        }catch(Exception e){}
    }
    
    public BufferedImage getBufferedImage(){
        return bim;
    }
    
    public void fillIt(){
        while(index != -1){
            cur = pixels[index];
            --index;
            //System.err.println("CHECKING SOUTH");            
            if(cur.y+1 < bim.getHeight() && bim.getRGB(cur.x, cur.y+1) == old){
                bim.setRGB(cur.x,cur.y+1,fill);
                ++index;
                pixels[index] = new coords(cur.x,cur.y+1);
            }
            //System.err.println("CHECKING NORTH");
            if(cur.y-1 >= 0 || bim.getRGB(cur.x, cur.y-1) == old){
                bim.setRGB(cur.x,cur.y-1,fill);
                ++index;
                pixels[index] = new coords(cur.x,cur.y-1);                
            }
            //System.err.println("CHECKING EAST");
            if(cur.x+1 < bim.getWidth() && bim.getRGB(cur.x+1, cur.y) == old){
                bim.setRGB(cur.x+1,cur.y,fill);
                ++index;
                pixels[index] = new coords(cur.x+1,cur.y);                
            }
            //System.err.println("CHECKING WEST");
            if(cur.x-1 >= 0 && bim.getRGB(cur.x-1, cur.y) == old){
                bim.setRGB(cur.x-1,cur.y,fill);
                ++index;
                pixels[index] = new coords(cur.x-1,cur.y);                
            }
            //end of while
        }
    }
}

class coords{
    public int x;
    public int y;
    public coords(int x1, int y1){
        x = x1;
        y = y1;
    }
}

